#!/bin/bash
########################################################################
#  yapkc.sh - Yet Another Port Knocking Client   		       #
#								       #
# Just specify the host you want to connect to		               #
#								       #
#   Copyright (C) 2007-2008  Anathema`				       #
#								       #
#   This program is free software: you can redistribute it and/or      #
#   modify it under the terms of the GNU General Public License as     #
#   published by the Free Software Foundation, either version 3 of the #
#   License, or any later version.				       #
#								       #
#   								       #
#   This program is distributed in the hope that it will be useful,    #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of     #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
#   GNU General Public License for more details.		       #
#								       #
#   You should have received a copy of the GNU General Public License  #
#   along with this program.  If not, see 			       #
#   <http://www.gnu.org/licenses/>.				       #
#								       #
#  Cheers to all ex-screw and ex-b.r. :)		               #
########################################################################


FILE="file.md5"

PASS="passwd"

function usage () {
            echo "Usage: $0 server port."
            exit 1
            }

if  [ ${#} -lt 2 ] || [ -z "${PASS}" ] || ! [ -s "${PASS}" ]; then #check if file exist and isn't null and number of params
            usage
fi

           echo "[+] Creating md5 hash file..."
           md5sum ${PASS} > ${FILE}

           echo "[+] Sending passwd hash file to ${1} on port ${2}..."
           send=$(cat ${FILE} | nc ${1} ${2} -q 1 &>/dev/null; echo $?)
             if [ ${send} != 0 ]; then
                  echo "[!] Can't connect to ${1} on ${2} ."
                  rm ${FILE}
		  exit 1
             else
                 echo "[*] Key sent."
                 echo "[*] Now try to login via ssh!"
              fi

 rm ${FILE}
exit 0
